<template>
  <ob-order-template
    :breadcrumbs="breadcrumbs"
    :order-id="order.number"
    :dateAndType="dateAndType"
    :total="actualTotal"
    @changeTab="hasActiveTab"
  >
    <template slot="left">
      <div v-if="numActiveStep === 1" class="order-step">
        <div class="order-step__header">
          <div>
            <div class="order-step__contractor">
              Исполнитель:
              <ob-inline-select
                ref="contractorSelect"
                v-model="contractor.uuid"
                :items="contractors"
                :inheritWidth="false"
                @input="onContractorSelect"
                label="Выбрать исполнителя"
              >
                <template v-slot="{items}">
                  <div :class="['ob-inline-select__list-item', {'top': item.top}]" v-for="item in items" :key="item.uuid" @click="selectContractor(item)">
                    <i v-if="item.icon" :class="['icon', item.icon]" />
                    {{item.title}}
                  </div>
                </template>
              </ob-inline-select>
            </div>
            <div>Тип заказа: {{ mocks.orderType }}</div>
          </div>
          <div class="upload">
            <i class="icon excel upload__icon"></i>
            <span class="upload__xls">Загрузить заказ из XLS-файла</span>
          </div>
        </div>
        <div class="order-step__route">
          <h2 :class="{ active: isRouteValid }" class="order-step-title">
            Маршрут
            <i class="icon checked"></i>
          </h2>
          <ob-drop @drop="onDrop">
            <div class="order-route">
              <ob-drag :transferData="addressFrom">
                <div class="order-route__row">
                  <div class="order-route__location">
                    <div class="order-route__location-input">
                      <ObAddressInput
                        display-exp="russian_address"
                        title="Откуда"
                        :locationsTypes="locationsTypes"
                        :address="addressFrom.label"
                        :mapAddress="mapAddressFrom"
                        :isValid="addressFrom.isValid"
                        :popoverMessage="addressFrom.popoverMessage"
                        :prefixIcon="addressFrom.icon || ''"
                        placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
                        mapId="map-2"
                        @input="setAddressFrom"
                        @on-change-address="setAddressFrom"
                      />
                    </div>
                    <div
                      class="order-route__points"
                      v-if="fromPointsShow || toPointsShow"
                    >
                      <ob-stepper
                        v-model="fromPoints"
                        label="Точки посещения"
                        :min-value="1"
                        class="order-route__stepper"
                        @input="changePoints"
                        v-show="fromPointsShow"
                      />
                    </div>
                  </div>
                  <div class="order-route__date">
                    <ob-date-picker
                      v-if="dateAndType.type === '0'"
                      v-model="dateAndType.date"
                      :label="dateAndTypeLable"
                      :isTime="true"
                      @input="setFromDate"
                    >
                      <div style="display:flex; justify-content: space-around">
                        <ob-radio
                          label="Погрузка"
                          valueInput="0"
                          v-model="dateAndType.type"
                          @change="dateAndTypeChanged"
                        />

                        <ob-radio
                          label="Отгрузка"
                          valueInput="1"
                          v-model="dateAndType.type"
                          @change="dateAndTypeChanged"
                        />
                      </div>
                    </ob-date-picker>
                  </div>
                </div>
              </ob-drag>
              <ob-drag :transferData="addressTo">
                <div class="order-route__row">
                  <div class="order-route__location">
                    <div class="order-route__location-input">
                      <ObAddressInput
                        display-exp="russian_address"
                        title="Куда"
                        :locationsTypes="locationsTypes"
                        :address="addressTo.label"
                        :mapAddress="mapAddressTo"
                        :isValid="addressTo.isValid"
                        :popoverMessage="addressTo.popoverMessage"
                        :prefixIcon="addressTo.icon || ''"
                        placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
                        @input="setAddressTo"
                        mapId="map-3"
                        @on-change-address="setAddressTo"
                      />
                    </div>
                    <div
                      class="order-route__points"
                      v-if="toPointsShow || fromPointsShow"
                    >
                      <ob-stepper
                        v-model="toPoints"
                        label="Точки посещения"
                        :min-value="1"
                        class="order-route__stepper"
                        @input="changePoints"
                        v-show="toPointsShow"
                      />
                    </div>
                  </div>
                  <div class="order-route__date">
                    <ob-date-picker
                      v-if="dateAndType.type === '1'"
                      v-model="dateAndType.date"
                      :label="dateAndTypeLable"
                      :isTime="true"
                      @input="setToDate"
                    >
                      <div style="display:flex; justify-content: space-around">
                        <ob-radio
                          label="Погрузка"
                          valueInput="0"
                          v-model="dateAndType.type"
                          @change="dateAndTypeChanged"
                        />

                        <ob-radio
                          label="Отгрузка"
                          valueInput="1"
                          v-model="dateAndType.type"
                          @change="dateAndTypeChanged"
                        />
                      </div>
                    </ob-date-picker>
                  </div>
                </div>
              </ob-drag>
            </div>
          </ob-drop>
        </div>
        <div class="order-step__method">
          <h2
            :class="[
              'order-step-title',
              { active: this.statusList[0][1].isTrue }
            ]"
          >
            Способ перевозки
            <i class="icon checked"/>
          </h2>
          <div class="order-methods">
            <div class="ctrl-group">
              <ob-button
                v-for="(method, index) in mocks.methods"
                :class="{ active: index === 0 }"
                :disabled="index !== 0"
                :key="method"
                type="flat"
                :label="method"
              />
            </div>
          </div>
          <h3 class="order-step-subtitle">
            Какой автотранспорт использовать?
          </h3>
          <div class="order-method-options">
            <ob-select
              v-model="transport"
              label="Вид автотранспорта"
              :items="transports"
              placeholder="Выберите из списка"
              position="top"
              @input="changeTransport"
            />
            <ob-select
              v-model="transportType"
              label="Тип автотранспорта"
              :items="transportTypes"
              placeholder="Выберите из списка"
              position="top"
              :disabled="!transport"
              @input="setTransportType"
            />
            <ob-stepper
              v-model="transportQty"
              label="Кол-во(шт)"
              :min-value="1"
              @input="setTransportQty"
            />
          </div>
          <div class="order-methods">
            <div class="ctrl-group ob-display-inline">
              <ob-button
                :class="{ active: needTracking }"
                type="flat"
                label="Трекинг груза"
                icon="radar"
                tooltip="Отслеживание передвижение заказа с помощью специальных приборов - “пломб”, устанавливаемых на транспортные средства"
                @click="changeTracking"
              />
              <ob-button
                :class="{ active: isDangerous }"
                type="flat"
                label="Опасный груз"
                icon="hazard"
                tooltip="К опасным грузам относятся любые вещества, материалы, изделия, отходы производственной и иной деятельности, которые в силу присущих им свойств и особенностей могут при их перевозке создавать угрозу для жизни и здоровья людей."
                @click="changeDangerous"
              />
              <ob-select
                v-model="temperatureСondition"
                :items="temperatureСonditions"
                placeholder="Выберите из списка"
                label=""
                @input="saveOrder"
              />
            </div>
          </div>
        </div>
        <h2 class="order-step-title">Buttons to test location validation</h2>
        <div class="validation-buttons">
          <div class="ctrl-group">
            <ob-button
              type="flat"
              label="Wrong country"
              @click.native="setWrongValidation('country')"
            />
            <ob-button
              type="flat"
              label="Same address"
              @click.native="setWrongValidation('same')"
            />
            <ob-button
              type="flat"
              label="Address not found"
              @click.native="setWrongValidation('notFound')"
            />
            <ob-button
              type="flat"
              label="Clear errors"
              @click.native="clearValidation"
            />
          </div>
          <div class="ctrl-group">
            <ob-button
              type="flat"
              label="Fill test data"
              @click.native="testData(0)"
            />
          </div>
        </div>
      </div>
      <div v-if="numActiveStep == 2" class="order-step">
        <div class="order-step__rout-info">
          <ob-card-path :dots="itemsDots" />
        </div>
        <div class="order-step__weight">
          <h2 class="order-step-title">
            Вес и объём груза
            <i class="icon checked"></i>
          </h2>
          <div class="input-group">
            <ob-input
              v-model="weightInKg"
              placeholder="Укажите вес"
              label="Общий вес груза"
              subTitle="т"
              @input="debouncedSaveOrder"
            />
            <ob-input
              v-model="volumeInCubicMeters"
              placeholder="Укажите объём"
              label="Общий объём груза"
              subTitle="м3"
              @input="debouncedSaveOrder"
            />
            <ob-input
              v-model="palletCount"
              placeholder="Укажите кол-во"
              label="Количество паллет"
              subTitle="пл"
              @input="debouncedSaveOrder"
            />
          </div>
          <div class="accounting">
            <div>
              <ob-radio
                v-model="accountingType"
                valueInput="BY_PACKAGE"
                label="Учёт по грузовым местам"
                @change="saveOrder"
              />
            </div>
            <div>
              <ob-radio
                v-model="accountingType"
                valueInput="BY_VENDOR_CODE"
                label="Поартикульный учёт"
                @change="saveOrder"
              />
            </div>
            <ob-select
              v-model="freightForwardingUnitUuid"
              label="Единица экспедиторского учёта"
              placeholder="Выберите из списка"
              :items="accountingItems"
              @input="saveOrder"
            />
          </div>
        </div>
        <div class="order-step__sides">
          <h2
            :class="{
              active: statusList[1][0].isTrue && statusList[1][1].isTrue
            }"
            class="order-step-title"
          >
            Грузоотправители и грузополучатели
            <i class="icon checked"></i>
          </h2>
          <div class="order-step__cards-container">
            <div class="order-step__card">
              <div class="order-step__card-header">
                Грузоотправители
                {{ visitPointConsignor.infograph.infograph_uuid ? ' 1' : ' 0' }}
                /1
              </div>
              <div class="order-step__card-item">
                <div class="order-step__card-city">
                  {{ cardConsignorData.subtitle }}
                  <i class="icon plus"></i>
                </div>
                <ob-card
                  v-if="visitPointConsignor"
                  @click="openVisitPointModal({ type: 'CONSIGNOR' })"
                  :type="cardConsignorData.type"
                  :title="cardConsignorData.title"
                  :locationLabel="cardConsignorData.locationLabel"
                  :subtitle="cardConsignorData.subtitle"
                  :date="cardConsignorData.date"
                  :time="cardConsignorData.time"
                  :location="cardConsignorData.location"
                  :error="cardConsignorData.error"
                />
              </div>
            </div>
            <div class="order-step__card">
              <div class="order-step__card-header">
                Грузополучатели
                {{ visitPointConsignee.infograph.infograph_uuid ? ' 1' : ' 0' }}
                /1
              </div>
              <div class="order-step__card-item">
                <div class="order-step__card-city">
                  {{ cardConsigneeData.subtitle }}
                  <i class="icon plus"></i>
                </div>
                <ob-card
                  v-if="visitPointConsignee"
                  @click="openVisitPointModal({ type: 'CONSIGNEE' })"
                  :type="cardConsigneeData.type"
                  :title="cardConsigneeData.title"
                  :locationLabel="cardConsigneeData.locationLabel"
                  :subtitle="cardConsigneeData.subtitle"
                  :date="cardConsigneeData.date"
                  :time="cardConsigneeData.time"
                  :location="cardConsigneeData.location"
                />
              </div>
            </div>
          </div>
        </div>
        <h2 class="order-step-title" style="margin-top: 40px">Тест валидации грузоотправителя и грузополучателя</h2>
        <div class="validation-buttons" style="margin-bottom: 10px;">
          <div class="ctrl-group">
            <ob-button
              label="Указать грузоотправителя"
              @click.native="statusList[1][0].isTrue = true"
            />
            <ob-button
              label="Указать грузополучателя"
              @click.native="statusList[1][1].isTrue = true"
            />
          </div>
        </div>
        <div class="validation-buttons" style="margin-bottom: 25px;">
          <div class="ctrl-group">
            <ob-button
              label="Валидация карточки"
              @click.native="cardErrorMock = {
                time: 'Время слота конфликтует с временем другого получателя',
                location: 'Адрес совпадает с другим адресом'
              }"
            />
          </div>
        </div>
        <ob-modal
          ref="visitPointConsignorModal"
          :title="visitPointModalTitle"
          :titleSecond="visitPointModalSubtitle"
          size="medium"
          :is-submit-disabled="true"
          :is-show-controls="false"
        >
          <visit-point-modal
            :point="visitPointConsignor"
            :locationsTypes="locationsTypes"
            @card-updated="handleCardUpdated"
            @close="$refs.visitPointModal.close()"
          />
        </ob-modal>
        <ob-modal
          ref="visitPointConsigneeModal"
          :title="visitPointModalTitle"
          :titleSecond="visitPointModalSubtitle"
          size="medium"
          :is-submit-disabled="true"
          :is-show-controls="false"
        >
          <visit-point-modal
            :point="visitPointConsignee"
            :locationsTypes="locationsTypes"
            @card-updated="handleCardUpdated"
            @close="$refs.visitPointModal.close()"
          />
        </ob-modal>

      </div>
      <div v-if="numActiveStep == 3" class="order-step">
        <div class="order-step__rout-info">
          <ob-card-path :dots="itemsDots" />
        </div>
        <div class="order-step__type">
          <h2
            :class="{ active: statusList[2][0].isTrue }"
            class="order-step-title"
          >
            Тип груза и страховая стоимость
            <i class="icon checked"></i>
          </h2>
          <ob-select
            label="Тип груза"
            placeholder="Выберите из списка"
            :items="types"
            v-model="cargoTypeUuid"
            displayExp="name"
            @input="saveOrder"
          />
          <div class="order-ensurance">
            <ob-input
              v-model="insuranceCost"
              label="Страховая стоимость груза"
              placeholder="Укажите страховую стоимость"
              @input="saveEnsuranceCost"
            />
            <div class="order-ensurance__risk" v-if="mocks.ensurance">
              <span>2</span>
              Группа риска 2
            </div>
          </div>
        </div>
        <div class="order-step__contacts">
          <h2
            :class="{ active: statusList[2][1].isTrue }"
            class="order-step-title"
          >
            Номер заказа клиента и контактное лицо
            <i class="icon checked"></i>
          </h2>
          <div class="input-group">
            <ob-input
              v-model="externalNumber"
              label="№ заказа клиента"
              placeholder="Введите номер заказа клиента"
              @input="debouncedSaveOrder"
            />
            <ob-select
              v-model="insuranceContact"
              label="Контактное лицо клиента"
              placeholder="Выберите из списка"
              :items="contacts"
              @input="debouncedSaveOrder"
            />
            <ob-select
              v-if="insuranceContact"
              v-model="insuranceContactPhone"
              label="Контактный телефон лица"
              placeholder="Выберите из списка"
              :items="phones"
              @input="saveOrder"
            />
          </div>
        </div>
        <div class="order-step__comments">
          <h2 class="order-step-title">
            Комментарий
          </h2>
          <ob-input
            v-model="insurnanceComment"
            label="Комментарий"
            placeholder="Будет виден всем перевозчикам"
            @input="debouncedSaveOrder"
          />
        </div>
        <div class="order-step__security">
          <h2 class="order-step-title">
            Требования к сервису и безопасности
          </h2>
          <ob-select
            v-model="security"
            label="Если хотите, выберите из списка дополнительные требования"
            placeholder="Выберите из списка"
            icon="plus"
            :items="securityItems"
            :is-tagbox="true"
            :is-multiselect="true"
            @input="saveOrder"
          />
        </div>
      </div>
      <div v-if="numActiveStep == 4" class="order-step">
        <div class="order-step__rout-info">
          <ob-card-path :dots="itemsDots" />
        </div>
        <div class="order-step__services">
          <div class="order-services-header">
            <h2 class="order-step-title order-step-title--services">
              Автоперевозка выделенным транспортом по маршруту Москва → Санкт-Петербург
            </h2>
            <p>
              по договору
              <a href="#">№CTR19 123 4567</a>
              от 20.12.2019
            </p>
          </div>
          <div class="order-step__service-items">
            <h2 class="order-step-title">
              Услуги от платформы
            </h2>
            <div class="platform-services">
              <service-card
                v-for="(service, index) in mocks.services.platform"
                :key="index"
                :name="service.name"
                :price="service.price"
                :icon="service.icon"
                :active="isServiceActive(service.name)"
                @serviceChanged="onServiceChanged"
              />
            </div>
          </div>
          <div class="order-step__service-items">
            <h2 class="order-step-title">
              Базовые услуги
            </h2>
            <div class="base-services">
              <div class="order-step__service-route">
                <button
                  :class="{ closed: !baseServicesExpanded }"
                  @click="toggleBaseServicesVisibility"
                >
                  <i class="icon chevron-up"></i>
                </button>
                <i class="icon pin" />
                <span
                  >Россия, Московская обл. г. Долгопрудный, ул. Новое шоссе,
                  34</span
                >
                →
                <i class="icon pin" />
                <span
                  >Россия, Самарская обл. г. Кинель, ул. Промышленная, 13</span
                >
              </div>
              <expand-transition>
                <div v-if="baseServicesExpanded">
                  <table>
                    <thead>
                      <tr>
                        <th></th>
                        <th>наименование</th>
                        <th>география</th>
                        <th class="number">кол-во</th>
                        <th class="number">сумма с ндс, р</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr
                        v-for="service in mocks.services.base"
                        :key="service.name"
                      >
                        <td>
                          <ob-checkbox
                            label=""
                            :value="isServiceActive(service.name)"
                            disabled
                            @change="onBaseServiceChange($event, service)"
                          />
                        </td>
                        <td>{{ service.name }}</td>
                        <td>Москва → Санкт-Петербург</td>
                        <td class="number">1</td>
                        <td class="number">{{ service.price }}</td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </expand-transition>
            </div>
          </div>
        </div>
      </div>
    </template>
    <template slot="right">
      <ob-info-panel :info="mocks.info">
        <template slot="status">
          <div class='tariff-loader' v-if="isSearchingTariff">
            <h2>Поиск вариантов</h2>
            <img src='@/assets/images/search_tracking.gif' alt=''>
          </div>
          <div
            class="ob-order-info-status"
            v-if="numActiveStep !== 4 && !showTariff && !isSearchingTariff && !isLogchainError"
          >
            <div
              v-for="(i, key) in statusList[numActiveStep - 1]"
              :key="`order-status-${key}`"
              :class="i.isTrue ? 'active' : ''"
              class="ob-order-info-status-item"
            >
              <i :class="i.isTrue ? 'checked' : 'alert'" class="icon" />
              <span class="ob-order-info-status-label">{{ i.label }}</span>
            </div>
          </div>
          <div
            v-else-if="numActiveStep === 1 && showTariff"
            class="ob-order-info-status__tafiff"
          >
            <div v-if="!tariff && !isLogchainError" class="ob-order-info-status__tariff-header">
              <i class="icon info"></i>
              Нет тарифа из договора
            </div>
            <div v-else-if="isLogchainError" class='ob-order-info-status__tariff-header'>
              <i class="icon info"></i>
              Что-то пошло не так
            </div>
            <div
              v-else
              class="ob-order-info-status__tariff-header ob-order-info-status__tariff-header--exist"
            >
              <i class="icon checked"></i>
              Для вашего маршрута найдены тариф<br />из договора
            </div>
            <div v-if="!tariff && isLogchainError" class="ob-order-info-status__tariff-text">
              Попробуйте ещё раз позже
            </div>
            <div v-else-if="!tariff" class="ob-order-info-status__tariff-text">
              Измените маршрут, способ перевозки или выберите другого
              контрагента
            </div>
            <div v-else class="ob-order-info-status__tariff-info">
              <div
                class="ob-order-info-status__tariff-item"
              >
                <b>{{ new Intl.NumberFormat('ru-RU').format(tariff.totalPrice / 100) }} ₽</b>
                <p><i :class="['icon', contractor.icon]"></i>{{contractor.title}}</p>
              </div>
            </div>
          </div>
          <div v-else-if="numActiveStep === 4">
            <div class="services-status">
              <h3>Итоговая стоимость услуг</h3>
              <ul class="services-list">
                <li>
                  Базовые услуги <b>{{ baseTotal }}₽</b>
                </li>
                <li>
                  Услуги от платформы <b>{{ platformTotal }}₽</b>
                </li>
              </ul>
            </div>
            <div class="services-total">
              <p>
                К оплате <span>{{ totalServices }}₽</span>
              </p>
              <p>
                В том числе НДС
                <span>{{ totalServices > 0 ? "11 750 ₽" : "0₽" }}</span>
              </p>
            </div>
            <div class="oferta">
              <ob-checkbox label="" v-model="oferta" />
              <span>
                Принимаю условия
                <a href="#" @click.prevent="openOferta">Оферты</a> и выражаю
                согласие с ними
              </span>
            </div>
          </div>
        </template>
        <template slot="bottom">
          <div class="ob-order-button">
            <ob-button
              v-if="numActiveStep !== 4 && !showTariff && !isSearchingTariff"
              label="Продолжить"
              :isFullWidth="true"
              :disabled="!isActiveStepValid"
              @click="clickHandler"
            />
            <ob-button
              v-else-if="numActiveStep === 1 && showTariff && tariff"
              label="Продолжить"
              :isFullWidth="true"
              :disabled="!tariff"
              @click="clickHandler"
            />
            <ob-button
              v-else-if="numActiveStep === 1 && isLogchainError"
              label="Ок"
              :isFullWidth="true"
              @click="retryLogchain()"
            />
            <ob-button
              v-else-if="numActiveStep === 4"
              label="Оформить заказ"
              :disabled="!oferta"
              @click="changeOrderStatus"
            />
          </div>
        </template>
      </ob-info-panel>
    </template>
    <oferta-popup
      ref="oferta"
      @close="$refs.oferta.close()"
    >
      <p>Lorem ipsum dolor sit amet consectetur adipisicing elit. Exercitationem dolore maiores consequatur beatae placeat sed alias aliquid fugiat expedita quam, autem, eligendi saepe ad nostrum repellendus neque labore a obcaecati.</p>
    </oferta-popup>
  </ob-order-template>
</template>

<script>
import { uuid } from 'vue-uuid';
import debounce from 'debounce';
import moment   from 'moment';

import ObButton        from 'common-components/src/obComponents/obButton';
import ObCard          from 'common-components/src/obComponents/obCard';
import ObCardPath      from 'common-components/src/obComponents/obCardPath';
import ObCheckbox      from 'common-components/src/obComponents/obCheckbox';
import ObDatePicker    from 'common-components/src/obComponents/obDatePickerConstructor';
import ObInfoPanel     from 'common-components/src/obComponents/obInfoPanel';
import ObInlineSelect  from 'common-components/src/obComponents/obInlineSelect';
import ObInput         from 'common-components/src/obComponents/obInput';
import ObModal         from 'common-components/src/obComponents/obModal';
import ObOrderTemplate from 'common-components/src/obComponents/obMainTemplate/orderTemplate';
import ObRadio         from 'common-components/src/obComponents/obRadio';
import ObSelect        from 'common-components/src/obComponents/obSelect';
import ObStepper       from 'common-components/src/obComponents/obStepper';

import VisitPointModal  from './modal/visitPointModal';
import ExpandTransition from '@/components/ExpandTransition';
import ObAddressInput  from 'common-components/src/obComponents/obAddressInput';
import ObDrag           from '@/components/ObDrag';
import ObDrop           from '@/components/ObDrop';
import OfertaPopup      from '@/components/Oferta';
import ServiceCard      from '@/components/OrderService';

import { tokenData } from '@/tokenData';
import api           from '@/api';
import json          from '@/order-mock.json';

moment.updateLocale('ru', {
  longDateFormat: {
    LL: 'D MMMM'
  }
})

export default {
  name: 'TestOneOrderItem',
  components: {
    ExpandTransition,
    ObAddressInput,
    ObButton,
    ObCard,
    ObCardPath,
    ObCheckbox,
    ObDatePicker,
    ObDrag,
    ObDrop,
    ObInfoPanel,
    ObInlineSelect,
    ObInput,
    ObModal,
    ObOrderTemplate,
    ObRadio,
    ObSelect,
    ObStepper,
    OfertaPopup,
    ServiceCard,
    VisitPointModal,
  },
  locationTypes: {
    'жд станция': 'train-sm',
    'аэропорт': 'airplane-sm',
    'контейнерный порт': 'container-sm',
    'морской порт': 'ship-sm',
    'опорная точка': 'city-sm',
    'пограничный переход': 'restrict-sm',
    'пункт таможенного оформления/свх': 'police-sm'
  },
  temperatureIcons: {
    "4a40a2fe-c283-40e3-a402-b5a46fdebc05": "room-temperature",
    "e1fdc890-c81b-4d96-b1b4-3524597c679c": "freezing",
    "092d2879-0678-496b-b7ce-0da21f5941ea": "cooling"
  },
  pageMap: [
    "ROUTE",
    "BRIF",
    "PARAMETERS",
    "SERVICES"
  ],
  data() {
    return {
      allowTopNav: false,
      tariffTotal: 0,
      actualTotal: 0,
      logistUuid: "",
      logist: "",
      isSearchingTariff: false,
      baseLocations: [],
      showTariff: false,
      tariff: null,
      riskColor: null,
      addressFrom: { coordinates: {}, icon: "pin", label: '', isValid: true, popoverMessage: '' },
      addressTo:   { coordinates: {}, icon: "pin", label: '', isValid: true, popoverMessage: '' },
      isLogchainError: false,
      logchain: {
        routeLength: null,
        routeDuration: null,
        baseLocations: [
          {
            uuid: null,
            direction: "FROM",
            date: null
          },
          {
            uuid: null,
            direction: "TO",
            date: null
          }
        ],
        tariff: {}
      },
      fromPoints: 1,
      toPoints: 1,
      fromPointsShow: false,
      toPointsShow: false,
      locationsTypes: [],
      newUUID: uuid.v4(),
      isDangerous: false,
      weightInKg: '0',
      volumeInCubicMeters: '0',
      palletCount: '0',
      accountingType: 'BY_PACKAGE',
      freightForwardingUnitUuid: '',
      cargoTypeUuid: '',
      insuranceCost: '',
      externalNumber: '',
      insuranceContact: '',
      insuranceContactPhone: '',
      insurnanceComment: '',
      dateAndType: { type: '0', date: new Date() },
      numActiveStep: 1,
      itemsDots: {
        price: '',
        contractor: '',
        startDate: '',
        endDate: '',
        routeLength: 0,
        routeDuration: 0,
        dots: [
          {
            icon: 'city',
            title: 'Москва',
            type: 'dotLocation',
            date: '',
            dots: ['from', 'from', 'from']
          },
          {
            icon: 'truck',
            title: 'Изотерм. 20 т / 68 м3 / 33 пал ',
            type: 'dotAuto',
            count: 1,
          },
          {
            icon: 'city',
            title: 'Нижний Новгород',
            type: 'dotLocation',
            date: '',
            dots: ['to', 'to']
          }
        ]
      },
      mocks: json,
      baseServicesExpanded: true,
      oferta: false,
      info: {
        panelName: '',
        panelIcon: '',
        panelTopRows: []
      },
      cardErrorMock: {
        date: '',
        location: '',
        locationDoc: ''
      },
      statusList: [
        [
          { label: 'Укажите пункты "Откуда" и "Куда"', isTrue: this.isRouteValid },
          { label: 'Выберите способ перевозки'       , isTrue: false }
        ],
        [
          { label: 'Укажите грузоотправителя', isTrue: false },
          { label: 'Укажите грузополучателя',  isTrue: false }
        ],
        [
          { label: 'Укажите тип и страховую стоимость груза',        isTrue: false },
          { label: 'Укажите номер заказа клиента и контактное лицо', isTrue: false },
        ],
        [
          { label: 'Маршрут'           , isTrue: false },
          { label: 'Итоговая стоимость', isTrue: false },
          { label: 'К оплате'          , isTrue: false }
        ]
      ],
      order: {},
      breadcrumbs: [
        {
          id: 1,
          title: 'Маршрут и груз',
          isSelected: true
        },
        {
          id: 2,
          title: 'Бриф',
          isSelected: false
        },
        {
          id: 3,
          title: 'Параметры',
          isSelected: false
        },
        {
          id: 4,
          title: 'Услуги',
          isSelected: false
          }
        ],
        contractor: {uuid: '', title: ''},
        contractors: [
          {
            title: 'Любой исполнитель',
            uuid: '1',
            top: true
          },
          {
            title: 'Любой из моих контрагентов',
            uuid: '2',
            top: true
          }
        ],
      transports: [],
      temperatureСonditions: [],
      temperatureСondition: "",
      needTracking: false,
      transportType: "",
      transportTypes: [],
      transport: "",
      defaultTransport: "",
      transportQty: 1,
      accountingItems: [],
      types: [],
      contacts: [{"title": "Зайко Максим", "uuid": "d77fe6f2-281b-446a-8b07-ae466f3788a7"}, {"title": "Волков Эдуард", "uuid": "07356515-3286-4cd3-b170-079aabe78e97"}],
      phones: [{"title": "+7 (905) 120-45-97", "uuid": "5ec100210-194d-4c63-860d-fd1e3ad6437e"}, {"title": "+7 (905) 120-45-97", "uuid": "51"}],
      securityItems: [],
      security: [],
      visitPointModalTitle: '',
      visitPointModalSubtitle: '',
    }
  },
  created() {
    api.organisations.getParticipantInfo(tokenData.contractor_uuid)
      .then(res => {
        this.mocks.info.panelTopRows.client.value = res.data.title;
      }).catch((e) => {
      console.error(e);
      this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
    })
    const requests = [
      api.organisations.getParticipantsbyRole('clicar'),
      api.organisations.getParticipantsbyRole('carrier')
    ]
    Promise.all(requests)
      .then(res => {
        res[0].data.content.forEach(item => {
          this.contractors.push({
            title: item.title,
            uuid: item.uuid,
            icon: 'role-domain-owner'
          })
        });

        res[1].data.content.forEach(item => {
          this.contractors.push({
            title: item.title,
            uuid: item.uuid,
            icon: 'role-agent'
          })
        });

        if (this.contractor.title === "") {
          this.onContractorSelect(this.contractors[2].uuid);
        }
      }).catch((e) => {
      console.error(e);
      this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
    })
    api.locations
      .getLocationTypes()
      .then(res => {
        this.locationsTypes = res.data.content;
      }).catch((e) => {
      console.error(e);
      this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
    });

    api.dictionaries.resources.getResourceSpeciesByClass('e7519b46-faf4-11e9-8f0b-362b9e155667')
      .then(res => {
        this.transports = res;
        const def = res.find(item => {
          return item.title === 'Фура'
        });
        this.defaultTransport = def.uuid;
        this.transport = def.uuid;
        this.changeTransport();
      }).catch((e) => {
      console.error(e);
      this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
    })

    api.temperature.getTemperatureModeTypes()
      .then(res => {
        res.forEach(item => {
          item.icon = this.$options.temperatureIcons[item.uuid]
        })
        this.temperatureСonditions = res
      }).catch((e) => {
      console.error(e);
      this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
    })
  },
  computed: {
    mapAddressFrom() {
      return {
        ...!this.isEmptyObj(this.addressFrom.coordinates) && { coordinates: this.addressFrom.coordinates },
        ...this.addressFrom.label && { russian_address: this.addressFrom.label }
      }
    },
    mapAddressTo() {
      return {
        ...!this.isEmptyObj(this.addressTo.coordinates) && { coordinates: this.addressTo.coordinates },
        ...this.addressTo.label && { russian_address: this.addressTo.label }
      }
    },
    hasAddressFrom() {
      return !!this.addressFrom.label && this.addressFrom.isValid;
    },
    hasAddressTo() {
      return !!this.addressTo.label && this.addressTo.isValid;
    },
    isAddressesValid() {
      return this.addressFrom.isValid && this.addressTo.isValid;
    },
    isRouteValid() {
      return this.hasAddressFrom && this.hasAddressTo && this.isAddressesValid;
    },
    dateAndTypeLable() {
      return this.dateAndType.type === '0' ? 'Дата и время погрузки' : 'Дата и время выгрузки'
    },
    totalServices() {
      return this.mocks.selectedServices.reduce((acc, item) => {
        return acc + item.price
      }, 0);
    },
    platformTotal() {
      return this.mocks.selectedServices
        .filter(item => item.type === 'platform')
        .reduce((acc, item) => acc + item.price, 0)
    },
    baseTotal() {
      return this.mocks.selectedServices
        .filter(item => item.type === 'base')
        .reduce((acc, item) => acc + item.price, 0)
    },
    isActiveStepValid() {
      return this.statusList[this.numActiveStep - 1].every(step => step.isTrue);
    },
    isTransportValid() {
      return this.transport && this.transportType && this.transportQty;
    },
    isTypeAndEnsuranceValid() {
      return this.cargoTypeUuid && this.insuranceCost;
    },
    isNumberAndContactValid() {
      return this.externalNumber && this.insuranceContact && this.insuranceContactPhone;
    },
    points() {
      const hasPoints = (
        this.order &&
        this.order.route &&
        this.order.route.points &&
        this.order.route.points.length
      );
      if (!hasPoints) return [];

      return this.order.route.points;
    },
    visitPointConsignor() {
      if (!this.points.length) return;

      return this.points.find(point => point.infograph.type === 'CONSIGNOR');
    },
    visitPointConsignee() {
      if (!this.points.length) return;

      return this.points.find(point => point.infograph.type === 'CONSIGNEE');
    },
    cardConsignorData() {
      if (
        !this.visitPointConsignor ||
        !this.visitPointConsignor.infograph ||
        !this.visitPointConsignor.infograph.infograph_uuid
      ) return {
        date         : '',
        error        : this.cardErrorMock,
        location     : '',
        locationLabel: 'Фактический адрес',
        subtitle     : 'Москва',
        time         : '',
        title        : 'Указать отправителя',
        type         : 'down',
      };

      const timeSlot = this.visitPointConsignor.infograph;
      const time = `${timeSlot.startT}-${timeSlot.endT}`;
      return {
        time,
        date         : timeSlot.date,
        error        : this.cardErrorMock,
        location     : this.visitPointConsignor.params.addressTitle,
        locationLabel: 'Фактический адрес',
        subtitle     : 'Москва',
        title        : 'Указать отправителя',
        type         : 'down',
      }
    },
    cardConsigneeData() {
      if (
        !this.visitPointConsignee ||
        !this.visitPointConsignee.infograph ||
        !this.visitPointConsignee.infograph.infograph_uuid
      ) return {
        date         : '',
        location     : '',
        locationLabel: 'Фактический адрес',
        subtitle     : 'Санкт-Петербург',
        time         : '',
        title        : 'Указать получателя',
        type         : 'up',
      };

      const timeSlot = this.visitPointConsignee.infograph;
      const time = `${timeSlot.startT}-${timeSlot.endT}`;
      return {
        time,
        date         : timeSlot.date,
        location     : '',
        locationLabel: 'Фактический адрес',
        subtitle     : 'Санкт-Петербург',
        title        : 'Указать получателя',
        type         : 'up',
      };
    },
  },
  watch: {
    isTransportValid(val) {
      this.statusList[0][1].isTrue = Boolean(val);
    },
    isTypeAndEnsuranceValid(val) {
      this.statusList[2][0].isTrue = Boolean(val);
    },
    isNumberAndContactValid(val) {
      this.statusList[2][1].isTrue = Boolean(val);
    },
  },
  mounted() {
    if (this.$route.params.id === 'new-order') {
      this.saveOrder();
    } else {
      this.getOrder(this.$route.params.id).then(() => {
        if (this.points.length && this.visitPointConsignor && this.visitPointConsignor.params.locationTypeUuid) {
          api.locations
            .getLocationType(this.visitPointConsignor.params.locationTypeUuid)
            .then(res => {
              if (res.data.name === 'Опорная точка') {
                this.fromPointsShow = true;
                this.addressFrom.icon = 'city-sm';
              }
              this.addressFrom.location_type_uuid = this.visitPointConsignor.params.locationTypeUuid;
              const type = this.locationsTypes.find(item => item.uuid === this.visitPointConsignor.params.locationTypeUuid);
              this.addressFrom.icon = this.$options.locationTypes[type.name.toLowerCase()]
            }).catch((e) => {
            console.error(e);
            this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
          })
        }
        if (this.points.length && this.visitPointConsignee && this.visitPointConsignee.params.locationTypeUuid) {
          api.locations
            .getLocationType(this.visitPointConsignee.params.locationTypeUuid)
            .then(res => {
              if (res.data.name === 'Опорная точка') {
                this.toPointsShow = true;
                this.addressTo.icon = 'city-sm';
              }
              this.addressTo.location_type_uuid = this.visitPointConsignee.params.locationTypeUuid;
              const type = this.locationsTypes.find(item => item.uuid === this.visitPointConsignee.params.locationTypeUuid);
              this.addressTo.icon = this.$options.locationTypes[type.name.toLowerCase()]
            }).catch((e) => {
            console.error(e);
            this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
          })
        }

        if (this.order.contractorUuid) {
          this.onContractorSelect(this.order.contractorUuid);
        }

        this.needTracking = this.order.needTracking || false;
        this.isDangerous = this.order.isDangerous || false;
        this.transport = this.order.ftlParams?.speciesUuids || this.defaultTransport;
        if (this.transport) {
          this.changeTransport(true);
        }
        this.transportType = this.order.ftlParams?.typeUuids || "";
        this.transportQty = this.order.ftlParams?.count || 1;
        this.itemsDots.dots[1].count = this.transportQty
        this.temperatureСondition = this.order.temperatureRegimeUuid || "";

        const fromPoint = this.order.route?.points.find(
          item => item.direction === 'FROM'
        );
        if (fromPoint) {
          this.addressFrom.coordinates.lat = fromPoint.params.coordinates[0] || '';
          this.addressFrom.coordinates.lon = fromPoint.params.coordinates[1] || '';
          this.addressFrom.label = fromPoint.params.addressTitle || '';
          this.fromPoints = fromPoint.visitPointCount || 0;
        }
        this.addressFrom.isValid = true;
        this.addressFrom.popoverMessage = '';

        const toPoint = this.order.route?.points.find(
          item => item.direction === 'TO'
        );
        if (toPoint) {
          this.addressTo.coordinates.lat = toPoint.params.coordinates[0] || '';
          this.addressTo.coordinates.lon = toPoint.params.coordinates[1] || '';
          this.addressTo.label = toPoint.params.addressTitle || '';
          this.toPoints = toPoint.visitPointCount || 0;
        }
        this.addressTo.isValid = true;
        this.addressTo.popoverMessage = '';

        this.dateAndType.type = this.order.route?.departureDt
          ? '0'
          : new Date(this.order.route.arriveDt)
          ? '1'
          : '0';
        this.dateAndType.date = this.order.route?.departureDt
          ? new Date(this.order.route.departureDt)
          : this.order.route.arriveDt
          ? new Date(this.order.route.arriveDt)
          : new Date();

        if (this.dateAndType.type === "0") {
          this.itemsDots.startDate = moment(this.dateAndType.date).format("LL");
        }

        if (this.dateAndType.type === "1") {
          this.itemsDots.endDate = moment(this.dateAndType.date).format("LL");
        }

        this.weightInKg = this.order.cargo?.weightInKg || "0";
        this.riskColor = this.order.riskColor || null;
        this.volumeInCubicMeters = this.order.cargo?.volumeInCubicMeters || "0";
        this.palletCount = this.order.cargo?.palletCount || "0";
        this.accountingType = this.order.cargo?.accountingType || "BY_PACKAGE";
        this.freightForwardingUnitUuid =
          this.order.cargo?.freightForwardingUnitUuid || '';

        this.cargoTypeUuid = this.order.parameters?.cargoTypeUuid || '';
        this.insuranceCost =
          this.order.parameters?.insuranceCargo?.cost || '';
        this.externalNumber = this.order.externalNumber || '';
        this.insuranceContact =
          this.order.parameters?.contactPerson?.uuid || '';
        this.insuranceContactPhone =
          this.order.parameters?.contactPerson?.phone || '';
        this.insurnanceComment = this.order.parameters?.comments || '';

        if (this.isRouteValid) {
          this.statusList[0][0].isTrue = true;
        }

        if (this.order.page && this.order.page !== "ROUTE") {
          const index = this.$options.pageMap.indexOf(this.order.page) + 1;
          console.log('page index ->', index);

          this.numActiveStep = index;
          this.changeTab({id: index});
          this.openTab({id: index});
        }
      });
    }
  },
  methods: {
    dateAndTypeChanged(e) {
      console.log('type changed', e);
      this.saveOrder();
    },
    getLength(value) {
      return Math.floor(value / 1000);
    },
    getDuration(duration) {
      const fm = [
          Math.floor(duration / (3600 * 24)),
          Math.floor(duration % (3600 * 24) / 3600),
      ];
      return fm.map((v, i) => {
          if (v) {
            if (i === 0) {
                v = this.plural(v, 'день | дня | дней');
            } else if (i === 1) {
                v = this.plural(v, 'час | часа | часов');
            } else if (i === 2) {
                v = this.plural(v, 'минута| минуты | минут');
            } else if (i === 3) {
                v = this.plural(v, 'секунда | секунды | секунд');
            }
            return v;
          }

      }).join(', ');
    },
    plural(value, unit) {
      return value + this.declOfNum(value, unit)
    },
    declOfNum(n, string){
      let titles = string.split('|');
      return titles[(n%10==1 && n%100!=11) ? 0 : n%10>=2 && n%10<=4 && (n%100<10 || n%100>=20) ? 1 : 2];
    },
    setTransportQty() {
      this.itemsDots.dots[1].count = this.transportQty;
      this.saveOrder();
    },
    getLogist(uuid) {
      api.users.getUserInfo(uuid)
        .then(res => {
          this.logist = `${res.responseUserInfo.firstname} ${res.responseUserInfo.lastname}`
        }).catch((e) => {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      })
    },
    setFromDate($event) {
      this.itemsDots.startDate = moment($event).format('LL');
      this.showTariff = false;
      this.saveOrder();
    },
    setToDate($event) {
      this.itemsDots.endDate = moment($event).format('LL')
      this.showTariff = false;
      this.saveOrder();
    },
    openOferta() {
      this.$refs.oferta.open();
    },
    selectContractor(item) {
      this.contractor.uuid = item.uuid;
      this.onContractorSelect(item.uuid, true);
    },

    debouncedSaveOrder: debounce(function() {
      this.saveOrder();
    }, 500),

    saveEnsuranceCost: debounce(function() {
      api.orders.getOrderRisks(this.cargoTypeUuid, this.insuranceCost)
        .then(res => {
          this.riskColor = res.data.color
          this.saveOrder();
        }).catch((e) => {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      })
    }, 500),

    isEmptyObj(obj) {
      for (var key in obj) {
        if (obj.hasOwnProperty(key)) {
          return false;
        }
      }
      return true;
    },
    async changeTransport(save) {
      try {
        const types = await api.dictionaries.resources.getOrderResourcesTypesBySpecies(this.transport);
        this.transportTypes = types;
        this.showTariff = false;
        if (save) {
          this.saveOrder();
        }
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },
    setTransportType() {
      const transport = this.transportTypes.find(item => item.uuid === this.transportType);
      this.itemsDots.dots[1].title = transport.title
      this.showTariff = false;
      this.saveOrder();
    },
    onDrop() {
      const tempAddress = { ...this.addressFrom };
      this.addressFrom = { ...this.addressTo };
      this.addressTo = { ...tempAddress };
      this.saveOrder();
    },
    changeTracking() {
      this.needTracking = true;
      this.saveOrder();
    },
    changeDangerous() {
      this.isDangerous = true;
      this.saveOrder();
    },
    changePoints() {
      this.saveOrder();
    },
    setAddressFrom($event) {
      this.addressFrom = $event;
      this.addressFrom.isValid = !!this.addressFrom.coordinates.lat && !!this.addressFrom.coordinates.lon;
      if (!this.addressFrom.isValid) {
        this.addressFrom.popoverMessage = "Адрес не найден. Выберите существующий адрес из списка или укажите точку на карте";
        this.statusList[0][0].isTrue = false;
        return false;
      }
      if (!$event.icon) {
        this.addressFrom.icon = 'pin';
      }
      if (this.isRouteValid) {
        this.statusList[0][0].isTrue = true;
      }

      if (this.addressFrom.icon && this.addressFrom.icon == 'city-sm') {
        // опорная точка
        this.fromPointsShow = true;
      } else {
        // не опорная точка
        this.fromPoints = 1;
        this.fromPointsShow = false;
      }
      this.showTariff = false;
      this.editVisitPoint({ direction: 'FROM' })
      this.saveOrder();
    },
    setAddressTo($event) {
      this.addressTo = $event;
      this.addressTo.isValid = !!this.addressTo.coordinates.lat && !!this.addressTo.coordinates.lon;
      if (!this.addressTo.isValid) {
        this.addressTo.popoverMessage = "Адрес не найден. Выберите существующий адрес из списка или укажите точку на карте";
        this.statusList[0][0].isTrue = false;
        return false;
      }
      if (!$event.icon) {
        this.addressTo.icon = 'pin'
      }
      if (this.isRouteValid) {
        this.statusList[0][0].isTrue = true;
      }

      if (this.addressTo.icon && this.addressTo.icon == 'city-sm') {
        // опорная точка
        this.toPointsShow = true;
      } else {
        // не опорная точка
        this.toPoints = 1;
        this.toPointsShow = false;
      }
      this.showTariff = false;
      this.editVisitPoint({ direction: 'TO' })
      this.saveOrder();
    },
    getOrder(uuid) {
      return api.orders.getOrder(uuid).then(response => {
        this.order = {
          ...response.data.responseDraft,
          creators: response.data.creators,
          cargo: response.data.cargo,
          parameters: response.data.parameters,
          logchain: response.data.logchain || {}
        };
      }).catch((e) => {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      })
    },
    async saveOrder() {
      let notificationId = new Date().getTime() + 'save';
      try {
        this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
        if (this.$route.params.id === 'new-order') {
          const number = await api.orders.getOrderId();
          this.order.number = number.data.code;
        }
        this.onOrderSave();
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      } finally {
        this.$notification({event: 'close', id: notificationId})
      }
    },

    onOrderSave() {
      let form = {
        bodySaveDraft: {
          page: this.$options.pageMap[this.numActiveStep - 1],
          logistUuid: this.logistUuid,
          number: this.order.number,
          clientUuid: tokenData.contractor_uuid,
          contractorUuid: this.contractor.uuid || '',
          externalNumber: this.externalNumber,
          orderType: 'STANDARD',
          orderSpecies: 'QUOTA',
          temperatureRegimeUuid: this.temperatureСondition,
          riskColor: this.riskColor,
          route: {
            departureDt:
              this.dateAndType.type === '0' ? this.dateAndType.date : '',
            arriveDt:
              this.dateAndType.type === '1' ? this.dateAndType.date : '',
            isCrossborder: false,
            points: this.points,
          },
          ftlParams: {
            speciesUuids: this.transport,
            typeUuids: this.transportType,
            count: this.transportQty
          },
          isDangerous: this.isDangerous,
          needTracking: this.needTracking
        },
        creators: {
          userUuid: this.order.creators?.userUuid || tokenData.user_uuid,
          contractorUuid: this.order.creators?.contractorUuid || tokenData.contractor_uuid
        },
        cargo: {
          weightInKg: this.weightInKg,
          volumeInCubicMeters: this.volumeInCubicMeters,
          palletCount: this.palletCount,
          accountingType: this.accountingType,
          freightForwardingUnitUuid: this.freightForwardingUnitUuid
        },
        parameters: {
          cargoTypeUuid: this.cargoTypeUuid,
          insuranceCargo: {
            cost: this.insuranceCost,
            currency: 'RUR'
          },
          contactPerson: {
            uuid: this.insuranceContact,
            phone: this.insuranceContactPhone
          },
          comments: this.insurnanceComment
        },
        logchain: {
          ...this.logchain
        }
      };

      let newUUID =
        this.$route.params.id === 'new-order'
          ? uuid.v4()
          : this.$route.params.id;
      let notificationId = new Date().getTime()+'save';
      this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
      api.orders.saveOrder(newUUID, form).then(() => {
        this.$router.push(`/order-item/${newUUID}`);
        this.getOrder(newUUID);
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
      }).catch((e)=>{
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      }).finally(()=>{
        this.$notification({event: 'close', id: notificationId})
      });
    },
    isServiceActive(name) {
      return !!this.mocks.selectedServices.filter(item => item.name === name)
        .length;
    },
    onBaseServiceChange($event, service) {
      const newService = { ...service, type: 'base' };
      if ($event) {
        this.mocks.selectedServices.push(newService);
        this.saveOrder();
        return;
      }
      this.mocks.selectedServices = this.mocks.selectedServices.filter(
        item => item.name !== newService.name
      );
      this.saveOrder();
    },
    toggleBaseServicesVisibility() {
      this.baseServicesExpanded = !this.baseServicesExpanded;
    },
    onServiceChanged($event) {
      if ($event.status) {
        const newService = { ...$event.event, type: 'platform' };
        this.mocks.selectedServices.push(newService);
        this.saveOrder();
        return;
      }
      this.mocks.selectedServices = this.mocks.selectedServices.filter(
        item => item.name !== $event.event.name
      );
      this.saveOrder();
    },

    onDateChanged($event) {
      this.dateAndType = $event;
    },
    onInput($event) {
      this.statusList[0][0].isTrue = $event.hasOwnProperty('coordinates');

      this.order.route = {
        address: $event,
        points: !!$event.icon,
        hasCoordinates: $event.hasOwnProperty('coordinates')
      };
    },

    clickHandler() {
      const id = this.numActiveStep + 1;
      if (id === 2) {
        if (this.showTariff && this.tariff) {
          this.showTariff = false;
          this.changeTab({ id });
          this.openTab({ id });
          return true;
        }
        this.isSearchingTariff = true;
        this.getLogChain();
        return false;
      }
      this.changeTab({ id });
      this.openTab({ id });
    },

    retryLogchain() {
      this.isLogchainError = false;
      this.showTariff = false;
    },

    getLogChain() {
      api.orders
        .createLogChain([
          {
            coordinate: [
              this.addressFrom.coordinates.lat,
              this.addressFrom.coordinates.lon
            ],
            direction: 'FROM',
            date: this.dateAndType.type === '0' ? this.dateAndType.date : ''
          },
          {
            coordinate: [
              this.addressTo.coordinates.lat,
              this.addressTo.coordinates.lon
            ],
            direction: 'TO',
            date: this.dateAndType.type === '1' ? this.dateAndType.date : ''
          }
        ])
          .then(res => {
            console.log("log chain ->", res);
            this.logchain = { ...res.data };
            this.itemsDots.routeLength = this.getLength(res.data.routeLength) + 'км' || '0 км';
            this.itemsDots.startDate = moment(res.data.baseLocations[0].date).format('LL');
            this.itemsDots.endDate = moment(res.data.baseLocations[1].date).format('LL');
            this.itemsDots.routeDuration = this.getDuration(res.data.routeDuration) || '0 дней';

            const locs = res.data.baseLocations.reduce((acc, item) => {
              acc.push(api.locations.getLocation(item.uuid));
              return acc;
            }, []);
            Promise.all(locs).then(res => {
              console.log('log locations ->', res);
              res.forEach(item => {
                this.baseLocations.push({
                  russian_name: item.data.russian_name,
                  coordinates: item.data.coordinates
                });
              });
              const transport = this.transportTypes.find(item => item.uuid === this.transportType);
              console.log('transport ->', transport);

              this.itemsDots.dots[0].title = this.baseLocations[0].russian_name
              this.itemsDots.dots[1].title = transport.title
              this.itemsDots.dots[2].title = this.baseLocations[1].russian_name
              api.orders.getOrderTariff( this.$route.params.id, {
                  "contractType": "shipping",
                  "clientUuid": tokenData.contractor_uuid,
                  "contractorUuid": this.contractor.uuid
                }
              )
                .then(res => {
                  console.log("tariff ->", res);
                  this.isSearchingTariff = false;
                  this.tariff = res.data.tariffInfo[0];
                  if (this.numActiveStep === 1) {
                    this.showTariff = true;
                  }
                  this.itemsDots.price = new Intl.NumberFormat('ru-RU').format(this.tariff.totalPrice / 100);
                  this.actualTotal = new Intl.NumberFormat('ru-RU').format(this.tariff.totalPrice / 100);
                  this.tariffTotal = new Intl.NumberFormat('ru-RU').format(this.tariff.totalPrice / 100);
                  this.mocks.services.base[0].price = new Intl.NumberFormat('ru-RU').format(this.tariff.totalPrice / 100);
                  this.mocks.selectedServices[0].price = new Intl.NumberFormat('ru-RU').format(this.tariff.totalPrice / 100);
                }).catch((e) => {
                  console.error(e);
                  this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                  this.isSearchingTariff = false;
                  if (this.numActiveStep === 1) {
                    this.showTariff = true;
                  }
                })
            }).catch((e) => {
              console.error(e);
              this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
            })
          }).catch((e) => {
            console.error(e);
            this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
            this.isLogchainError = true;
            this.isSearchingTariff = false;
            if (this.numActiveStep === 1) {
              this.showTariff = true;
            }
          });
    },

    changeOrderStatus() {
      console.log('change order status', this.order);
      let notificationId = new Date().getTime()+'save';
      this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
      api.orders.changeOrderStatus(this.$route.params.id, 'FORMED').then(() => {
        alert('Заказ сохранён');
        this.$router.push('/order-all/orders');
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
      }).catch((e)=>{
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      }).finally(()=>{
        this.$notification({event: 'close', id: notificationId})
      });
    },

    hasActiveTab(data) {
      this.openTab(data);
      this.changeTab(data);
    },
    openTab(data) {
      for (let i of this.breadcrumbs) {
        data.id >= i.id ? (i.isSelected = true) : (i.isSelected = false);
      }
    },
    changeTab: function(data) {
      switch (Number(data.id)) {
        case 2:
          api.resources
            .getForwardingUnitList()
            .then(res => {
              this.accountingItems = res.data.content.reduce(
                (acc, item) => {
                  acc.push({ uuid: item.uuid, title: item.description });
                  return acc;
                },
                []
              );
              console.log('units ->', res.data.content);
            }).catch((e) => {
            console.error(e);
            this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
          })
          break;
        case 3:
          api.cargo
            .getOrderCargoTypes(0, 76)
            .then(res => {
              console.log("cargo types ->", res);
              this.types = res.data.content;
            }).catch((e) => {
            console.error(e);
            this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
          });
          api.services.getServiceRequirements().then(res => {
            console.log("req ->", res);
            this.securityItems = res.data;
          }).catch((e) => {
            console.error(e);
            this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
          });
          break;
        default:
          break;
      }

      this.numActiveStep = data.id;
    },
    onContractorSelect($event, toggle) {
      this.showTariff = false;
      if (toggle) {
        this.$refs.contractorSelect.toggle();
      }

      const newContractor = this.contractors.find(
        item => item.uuid === $event
      );

      this.contractor.uuid = newContractor.uuid;
      this.contractor.title = newContractor.title;
      this.contractor.icon = newContractor.icon;
      this.itemsDots.contractor = this.contractor.title || "Zorro"
      if ($event !== '1' && $event !== '2') {
        api.orders.getOrderLogist(newContractor.uuid, tokenData.contractor_uuid)
          .then(res => {
            this.logistUuid = res.data.ResponseResponsibleWorker.uuid;
            api.users.getUserInfo(res.data.ResponseResponsibleWorker.uuid)
              .then(res => {
                this.logist = {
                  name: `${res.responseUserInfo.firstname} ${res.responseUserInfo.lastname}`,
                  phone: res.responseUserInfo.phone || '',
                  email: res.responseUserInfo.email || ''
                }
                this.mocks.info.panelTopRows.logist.visible = true;
                this.mocks.info.panelTopRows.contractor.value = newContractor.title;
                this.mocks.info.panelTopRows.contractor.visible = true;
                this.mocks.info.panelTopRows.contractor.icon = this.contractor.icon;
                this.mocks.info.panelTopRows.logist.value = this.logist.name;
                this.mocks.info.panelTopRows.logist.phone = this.logist.phone || '';
                this.mocks.info.panelTopRows.logist.email = this.logist.email || ''
                this.saveOrder();
              })
          }).catch((e) => {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        })
      } else {
        this.mocks.info.panelTopRows.logist.visible = false;
        this.mocks.info.panelTopRows.contractor.visible = false;
      }
    },
    setWrongValidation(prop) {
      const messages = {
        country:
          'Адреса погрузки находятся в разных таможенных союзах. Измените адреса погрузки или разбейте заказ на два',
        same: 'Адреса совпадают',
        notFound:
          'Адрес не найден. Выберите существующий адрес из списка или укажите точку на карте'
      };

      this.addressFrom.isValid = false;
      this.addressFrom.popoverMessage = messages[prop];
      this.addressTo.isValid = false;
      this.addressTo.popoverMessage = messages[prop];
    },
    setCardWrongValidation(prop) {
      switch (prop) {
        case 'time':
          this.timeMock.error =
            'Время слота конфликтует с временем другого получателя';
          break;

        case 'location':
          this.locationMock.error = 'Адрес совпадает с другим адресом';
          break;
      }
    },
    clearValidation() {
      this.addressFrom.isValid = true;
      this.addressFrom.popoverMessage = '';
      this.addressTo.isValid = true;
      this.addressTo.popoverMessage = '';
    },
    handleCardUpdated({ type, props, point }) {
      if (point) return null;
      if (type === 'consignor') {
        this.cardConsignorData = Object.assign(this.cardConsignorData, props)
      }
    },
    openVisitPointModal({ type }) {
      this.visitPointModalTitle    = `Данные по ${type === 'CONSIGNOR' ? 'грузоотправителю' : 'грузополучателю'}`;
      this.visitPointModalSubtitle = `Добавление. ${type === 'CONSIGNOR' ? this.cardConsignorData.subtitle : this.cardConsigneeData.subtitle }`
      if (type === 'CONSIGNOR') this.$refs.visitPointConsignorModal.open();
      if (type === 'CONSIGNEE') this.$refs.visitPointConsigneeModal.open();
    },
    editVisitPoint({ direction }) {
      // если точки нет - создаем новую
      const hasPoint = (
        (direction === 'FROM' && this.visitPointConsignor) ||
        (direction === 'TO'   && this.visitPointConsignee)
      );
      if (hasPoint) {
        const pointIndex = this.points.findIndex(point => point.direction === direction);
        this.$delete(this.order.route.points, pointIndex);
      }
      // если точка существует, то редактируем существующую
      const type = direction === 'FROM' ? 'CONSIGNOR' : 'CONSIGNEE';
      const address = direction === 'FROM' ? this.addressFrom : this.addressTo;
      const point = {
        direction,
        visitPointCount: 1,
        extraDistanceInKm: 10,
        type: 'ADDRESS',
        params: {
          uuid: uuid.v4(),
          coordinates: [
            address.coordinates.lat,
            address.coordinates.lon
          ],
          countryCode: 'RUS',
          locationUuid: address.locationUuid || '',
          locationTypeUuid: address.locationTypeUuid || '',
          addressTitle: address.label || '',
        },
        infograph: {
          type,
          infograph_uuid: '',
          title: '',
          timeSlot: {
            date: '2020-01-22',
            startT: '09:00',
            endT: '09:00'
          },
          comments: ''
        }
      };
      this.order.route.points.push(point);
    },
  }
}
</script>

<style lang="scss" scoped>
.order-step {
  padding: 10px 20px 25px;
}

.order-step__header {
  display: flex;
  align-items: center;
  justify-content: space-between;
  margin-bottom: 27px;

  div {
    display: flex;
    align-items: center;

    &:not(:last-child) {
      margin-right: 30px;
    }
  }

  .ob-inline-select {
    margin-left: 5px;
  }
}

.upload {
  display: none !important;
  align-self: flex-end;
  align-items: center;
  justify-content: center;

  &__xls {
    margin: 0 7px;
    font-size: 12px;
  }

  &__icon {
    line-height: 100%;
    padding-top: 4px;
    color: $orderPage-item_icon;
  }
}

.order-step__contractor {
  display: flex;
  align-items: center;

  .icon {
    display: flex;
    margin-left: 10px;
    color: $color-blue-navy-blue;
  }
}

.order-step-title {
  margin: 0 0 15px;
  font-weight: bold;
  font-size: 20px;
  line-height: 28px;
  letter-spacing: 0.4px;
  color: $color-text-base;
  display: flex;
  align-items: center;

  .icon {
    display: flex;
    margin-left: 6px;
    color: $color-grey-border;
  }

  &.active {
    .icon {
      color: $color-green-light;
    }
  }

  &--services {
    font-size: 24px;
    line-height: 36px;
    letter-spacing: 0.2px;
  }
}

.order-step-subtitle {
  margin: 0 0 15px;
  font-weight: bold;
  font-size: 16px;
}

.order-route__row {
  width: 100%;
  display: flex;
  margin: 8px 0 8px 0;
}

.order-route__location {
  flex: 0 0 80%;
  min-width: 250px;
  display: flex;

  @media screen and (max-width: 1450px) {
    flex: 0 0 70%;
  }
}

.order-route__location-input {
  flex-grow: 1;
}

.order-route__points {
  flex: 0 0 30%;
  max-width: 150px;
  margin-left: 10px;

  @media screen and (max-width: 1450px) {
    flex: 0 0 20%;
  }
}

.order-route__date {
  margin-left: 10px;
  z-index: 1;
  height: 52px;
  position: relative;
}

.order-methods {
  margin-bottom: 30px;
  display: flex;
}

.order-method-options {
  display: flex;
  margin-bottom: 30px;

  .form-item-container {
    margin-right: 10px;
    margin-bottom: 0;
    min-width: 180px;

    &:first-child {
      flex: 1 0 0;
    }

    &:nth-child(2) {
      flex: 3 0 0;
    }
  }

  .ob-stepper-container {
    width: 150px;
  }
}

.placeholder {
  background-color: $background-white;
  display: flex;
  font-size: 20px;
}

.ctrl-group .ob-button-container {
  display: flex;
  width: auto;
  padding: 0 15px;
  max-width: none;
  min-width: 135px;
  background: $background-white;
  color: $cobalt-blue;

  &.active, &:hover {
    background-color: $blue-blue-hoarfrost !important;
    color: $cobalt-blue !important;
  }

  border-radius: 0;
  height: 52px;
  border-left: 1px solid $color-grey-border;

  &:first-child {
    border: none;
  }
}

.order-step__rout-info {
  margin: -25px -20px 0;
  height: 200px;
  background-color: $background-white;
  display: flex;
  justify-content: center;
  align-items: center;
  box-shadow: 0px 4px 16px rgba($color-blue-navy-blue, 0.2);
  border-radius: 4px;
  font-size: 24px;
}

.order-step__weight {
  margin-top: 29px;
}

.input-group {
  display: flex;
  margin-bottom: 24px;

  & > * {
    margin-right: 20px;
  }
}

.accounting {
  div:first-child {
    margin-bottom: 5px;
  }

  .ob-selector {
    margin-top: 17px;
    max-width: 390px;
  }
}

.order-step__sides {
  margin-top: 26px;
}

.order-step__cards-container {
  display: flex;
}

.order-step__card {
  flex-grow: 1;
  max-width: 495px;
  padding-right: 105px;
}

.order-step__card-item {
  width: 100%;
}

.order-step__card-header {
  margin-bottom: 5px;
  font-size: 14px;
  color: $gray-slate;
}

.order-step__card-city {
  display: flex;
  justify-content: space-between;
  align-items: center;
  width: 100%;
  max-width: 410px;
  margin-bottom: 17px;
  font-size: 20px;
  font-weight: 700;

  &.active {
    .icon {
      color: $color-green-light;
    }
  }

  .icon {
    display: flex;
    justify-content: flex-end;
    align-items: center;
    color: $color-grey-border;
  }
}

.order-step__type {
  margin-top: 40px;

  .ob-selector {
    max-width: 653px;
  }
}

.order-ensurance {
  margin-top: 20px;
  display: flex;
  align-items: center;

  .ob-input-container {
    width: 100%;
    max-width: 317px;
  }
}

.order-ensurance__risk {
  margin-left: 24px;
  display: flex;
  align-items: center;

  span {
    width: 18px;
    height: 18px;
    display: flex;
    justify-content: center;
    align-items: center;
    border-radius: 50%;
    color: $orderPage-compact-ensurance_risk;
    font-size: 11px;
    background-color: $light-denim ;
    margin-right: 7px;
  }
}

.order-step__contacts,
.order-step__comments {
  margin-top: 36px;
}

.order-step__security {
  margin-top: 40px;
}

.order-step__services {
  margin-top: 40px;
}

.order-step__service-items {
  margin-top: 60px;
}

.platform-services {
  display: flex;

  & > .service {
    flex: 0 0 164px;

    &:not(:last-child) {
      margin-right: 9px;
    }
  }
}

.order-step__service-route {
  padding: 24px;
  font-size: 12px;
  color: $color-text-base;
  background-color: $background-color-light;

  button {
    margin-right: 28px;
    border: none;
    outline: none;
    background-color: transparent;
    appearance: none;
    font-size: 16px;
    color: $orderPage-compact-step_service_route_button;
    transition: all 0.2s ease-in-out;
  }

  .closed {
    transform: rotate(180deg);
  }
}

table {
  width: 100%;
  text-align: left;
  font-size: 14px;
  color: $color-text-base;
  border: 1px solid $lavender;

  th {
    padding: 10px;
    font-size: 11px;
    color: $shale-gray;
    text-transform: uppercase;
    font-weight: 400;

    &:first-child {
      width: 5%;
    }

    &:nth-child(2) {
      width: 40%;
    }

    &:nth-child(3) {
      width: 20%;
    }

    &:nth-child(4) {
      width: 10%;
    }

    &:last-child {
      width: 15%;
    }
  }

  td {
    padding: 10px;
    border-top: 1px solid $lavender;
  }

  .number {
    text-align: right;
  }
}

.services-list {
  margin-bottom: 20px;
  margin-top: 17px;
  font-weight: 400;

  li {
    display: flex;
    align-items: center;
    justify-content: space-between;
    font-size: 12px;

    &:not(:last-child) {
      margin-bottom: 9px;
    }
  }
}

.services-total {
  border-top: 1px solid $color-grey-border;
  padding-top: 20px;
  margin-bottom: 30px;

  p {
    display: flex;
    align-items: center;
    justify-content: space-between;
  }

  p:first-child {
    margin-bottom: 5px;
    font-size: 20px;
  }

  p:last-child {
    font-size: 12px;
    color: $gray-slate;
  }
}

.oferta {
  padding-top: 27px;
  padding-right: 27px;
  margin-bottom: 20px;
  display: flex;
  border-top: 1px solid $color-grey-border;
  font-size: 12px;
  color: $gray-slate;

  a {
    color: $orderPage-oferta_link_color;
  }
}

.ob-inline-select__list-item {
  display: flex;
  align-items: center;
  font-size: 14px;
  letter-spacing: 0.2px;
  color: $color-text-base;
  padding: 8px 16px;
  cursor: pointer;
  white-space: nowrap;

  &:first-child {
    padding-top: 16px;
  }
  &:last-child {
    padding-bottom: 16px;
  }

  &.top {
    border-bottom: 1px solid rgba($color-grey-border, 0.3);
  }

  .icon {
    margin-right: 5px;
    color: $color-blue-navy-blue;
  }
}

.ob-order-info-status__tafiff {
  margin-bottom: 30px;
}

.ob-order-info-status__tariff-header {
  margin-top: 5px;
  display: flex;
  align-items: center;
  font-size: 16px;
  line-height: 1.2;
  letter-spacing: 0.4px;
  font-weight: 700;

  .icon {
    margin-right: 16px;
    font-size: 24px;
  }

  .info {
    color: $color-error;
  }

  &--exist {
    color: $color-green-light;
    align-items: flex-start;
  }
}

.ob-order-info-status__tariff-text {
  margin-top: 18px;
  font-size: 14px;
  letter-spacing: 0.4px;
  color: $gray-slate;
}

.ob-order-info-status__tariff-info {
  margin-top: 36px;
}

.ob-order-info-status__tariff-item {
  b {
    font-size: 20px;
  }

  p {
    margin-top: 7px;
    font-size: 14px;
    line-height: 16px;
    letter-spacing: 0.4px;
    color: $color-text-base;

    .icon {
      position: relative;
      top: 2px;
      right: -1px;
      margin-right: 3px;
      color: $color-blue-navy-blue;
      font-weight: bold;
    }
  }
}

.tariff-loader {
  font-weight: bold;
  font-size: 20px;
  line-height: 28px;
  letter-spacing: 0.4px;
  color: $color-blue-navy-blue;
  text-align: center;

  img {
    max-width: 100%;
  }
}

::v-deep {
  .ob-info-block {
    background: white;
  }

  .ob-info-block__name {
    display: none;
  }
}

.validation-buttons {
  display: flex;
}
</style>
